config/routes.rb
Rails.application.routes.draw do
  devise_for :users,
                 controllers: {
                   sessions: 'users/sessions',
                   registrations: 'users/registrations',
                   passwords: 'users/passwords',
                 }
  devise_scope :user do
    post '/users/register' => 'users/registrations#create'
    get '/users/sign_out' => 'devise/sessions#destroy'
  end

  resources :users  

  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  root "home#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/role.rb
class Role < ApplicationRecord
  has_and_belongs_to_many :users, :join_table => :users_roles
  
  belongs_to :resource,
             :polymorphic => true,
             :optional => true
  

  validates :resource_type,
            :inclusion => { :in => Rolify.resource_types },
            :allow_nil => true

  scopify
end

app/models/user.rb
# frozen_string_literal: true

# # User model for adding users
class User < ApplicationRecord
  rolify
  
  devise :database_authenticatable, :registerable,
          :recoverable, :rememberable, :validatable,
          :authentication_keys => [:login]

  attr_accessor :login

  #validations
  validates :first_name , presence: true
  validates :email, format: Devise.email_regexp, if: -> { email.present? }
  validates :phone, format: { with: /\A\+(?:[0-9]●?){6,14}[0-9]\z/, message: "must be a phone number with country code" }, if: -> { phone.present? }
 
  def login
    @login || self.email || self.phone
  end

  def self.find_for_database_authentication(warden_conditions)
    conditions = warden_conditions.dup
    if login = conditions.delete(:login)
      where(conditions.to_h).where(["lower(email) = :value OR phone = :value", { :value => login.downcase }]).first
    else
      where(conditions.to_h).first
    end
  end

  def email_required?
    false
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  include Pundit::Authorization
  rescue_from Pundit::NotAuthorizedError, with: :user_not_authorized
  before_action :configure_permitted_parameters, if: :devise_controller?
  before_action :authenticate_user!


  private

  def user_not_authorized
    respond_to do |format|
      format.html { redirect_to root_url, notice: "You are not authorized to perform this action." }
    end
  end

  protected

  def configure_permitted_parameters
    devise_parameter_sanitizer.permit(:sign_up, keys: [:first_name, :last_name, :email, :phone])
    devise_parameter_sanitizer.permit :sign_in, keys: [:login, :password]
  end
end

app/controllers/concerns/send_welcome_email_or_sms.rb
module SendWelcomeEmailOrSms
  extend ActiveSupport::Concern

  def send_welcome_sms_and_email
    if params[:contact_method] == "Email"
      UserMailer.welcome_email(@user).deliver_now # Call the send_welcome_mail method
    elsif params[:contact_method] == "Phone"
      send_welcome_sms(@user) # Call the send_welcome_sms method
    else
      UserMailer.welcome_email(@user).deliver_now # Call the send_welcome_mail method
      send_welcome_sms(@user) # Call the send_welcome_sms method
    end
  end
end

app/controllers/home_controller.rb
# frozen_string_literal: true

class HomeController < ApplicationController

  def index
  end
end

app/controllers/users/confirmations_controller.rb
# frozen_string_literal: true

class Users::ConfirmationsController < Devise::ConfirmationsController
  # GET /resource/confirmation/new
  # def new
  #   super
  # end

  # POST /resource/confirmation
  # def create
  #   super
  # end

  # GET /resource/confirmation?confirmation_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after resending confirmation instructions.
  # def after_resending_confirmation_instructions_path_for(resource_name)
  #   super(resource_name)
  # end

  # The path used after confirmation.
  # def after_confirmation_path_for(resource_name, resource)
  #   super(resource_name, resource)
  # end
end

app/controllers/users/omniauth_callbacks_controller.rb
# frozen_string_literal: true

class Users::OmniauthCallbacksController < Devise::OmniauthCallbacksController
  # You should configure your model like this:
  # devise :omniauthable, omniauth_providers: [:twitter]

  # You should also create an action method in this controller like this:
  # def twitter
  # end

  # More info at:
  # https://github.com/heartcombo/devise#omniauth

  # GET|POST /resource/auth/twitter
  # def passthru
  #   super
  # end

  # GET|POST /users/auth/twitter/callback
  # def failure
  #   super
  # end

  # protected

  # The path used when OmniAuth fails
  # def after_omniauth_failure_path_for(scope)
  #   super(scope)
  # end
end

app/controllers/users/passwords_controller.rb
# frozen_string_literal: true

class Users::PasswordsController < Devise::PasswordsController
  # GET /resource/password/new
  # def new
  #   super
  # end

  # POST /resource/password
  # def create
  #   super
  # end

  # GET /resource/password/edit?reset_password_token=abcdef
  # def edit
  #   super
  # end

  # PUT /resource/password
  # def update
  #   super
  # end

  # protected

  # def after_resetting_password_path_for(resource)
  #   super(resource)
  # end

  # The path used after sending reset password instructions
  # def after_sending_reset_password_instructions_path_for(resource_name)
  #   super(resource_name)
  # end
end

app/controllers/users/registrations_controller.rb
# frozen_string_literal: true

class Users::RegistrationsController < Devise::RegistrationsController
  include SendWelcomeEmailOrSms

  def create
    build_resource(sign_up_params)
    resource.save
    resource.add_role(:student) if resource.roles.blank?
    send_welcome_sms_and_email
    yield resource if block_given?
    if resource.persisted?
      if resource.active_for_authentication?
        set_flash_message! :notice, :signed_up
        sign_up(resource_name, resource)
        respond_with resource, location: user_path(resource)
      else
        set_flash_message! :notice, :"signed_up_but_#{resource.inactive_message}"
        expire_data_after_sign_in!
        respond_with resource, location: after_inactive_sign_up_path_for(resource)
      end
    else
      clean_up_passwords resource
      set_minimum_password_length
      respond_with resource
    end
  end
end

app/controllers/users/sessions_controller.rb
# frozen_string_literal: true

class Users::SessionsController < Devise::SessionsController
  # before_action :configure_sign_in_params, only: [:create]

  # GET /resource/sign_in
  # def new
  #   super
  # end

  # POST /resource/sign_in
  # def create
  #   super
  # end

  # DELETE /resource/sign_out
  # def destroy
  #   super
  # end

  # protected

  # If you have extra params to permit, append them to the sanitizer.
  # def configure_sign_in_params
  #   devise_parameter_sanitizer.permit(:sign_in, keys: [:attribute])
  # end
end

app/controllers/users/unlocks_controller.rb
# frozen_string_literal: true

class Users::UnlocksController < Devise::UnlocksController
  # GET /resource/unlock/new
  # def new
  #   super
  # end

  # POST /resource/unlock
  # def create
  #   super
  # end

  # GET /resource/unlock?unlock_token=abcdef
  # def show
  #   super
  # end

  # protected

  # The path used after sending unlock password instructions
  # def after_sending_unlock_instructions_path_for(resource)
  #   super(resource)
  # end

  # The path used after unlocking the resource
  # def after_unlock_path_for(resource)
  #   super(resource)
  # end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: %i[ show destroy ]

  def index
    authorize(current_user, :admin?, policy_class: UserPolicy)
    @users = User.all
  end

  def show
    authorize(current_user, :admin_or_student?, policy_class: UserPolicy)
  end

  def destroy
    authorize(current_user, :admin_or_student?, policy_class: UserPolicy)
    @user.destroy

    respond_to do |format|
      format.html { redirect_to users_url, notice: "User was successfully destroyed." }
    end
  end

  private
    def set_user
      @user = User.find(params[:id])
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
  def user_in_and_out
    if user_signed_in?
  
      link_to(' Logout', destroy_user_session_path, class: 'grey-btn glyphicon glyphicon-log-in')
    else
      link_to(' Login', new_user_session_path, method: :delete, class: 'grey-btn glyphicon glyphicon-log-in', title: 'logout')
    end
  end

  # full_name
  def current_user_full_name
    "#{current_user.first_name.titleize} #{current_user.last_name.titleize}"
  end
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/base/_header.html.erb
<nav class="navbar navbar-inverse">
  <div class="container-fluid">
    <div class="navbar-header text-white">
      <a class="navbar-brand text-white" href="#">STUDENT REGISTER</a>
    </div>
    <ul class="nav navbar-nav">
    <% if user_signed_in? && current_user.has_role?(:student) %>
      <li class="nav-item">
        <%= link_to user_path(current_user), class:"nav-link sidebar-options" do %>
          <i class='nav-icon fa fa-home sidebar-menu-icon'></i>
          <p>Home</p>
        <% end %>
      </li>
    <% else %>
      <li class="nav-item">
        <%= link_to users_path, class:"nav-link sidebar-options" do %>
          <i class='nav-icon fa fa-home sidebar-menu-icon'></i>
          <p>Home</p>
        <% end %>
      </li>
    <% end %>
        
      <li class="nav-item">
        <%= link_to "#", class:"nav-link sidebar-options" do %>
          <i class='nav-icon fa fa-envelope-open sidebar-menu-icon'></i>
          <p class="ml-1"><%=  t 'base.sidebar.support-section' %></p>
        <% end %>
      </li>
    </ul>
    <ul class="nav navbar-nav navbar-right">
      <% if !user_signed_in? %>
        <li><%= link_to(' Register', new_user_registration_path, class: 'glyphicon glyphicon-user')%></li>
      <% end %>
      <li><%= user_in_and_out %></li>
    </ul>
  </div>
</nav>

app/views/home/index.html.erb
<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title><%= t '.welcome' %></title>
  </head>
  <body>
    <h1 align="center"><%= t '.Welcome' %></h1>
  </body>
</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Student Registration System</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.3/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-MrcW6ZMFYlzcLA8Nl+NtUVF0sA7MsXsP1UyJoMp4YLEuNSfAP+JcXn/tWtIaxVXM" crossorigin="anonymous"></script>

    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.5.0/font/bootstrap-icons.css">
    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
    <%= javascript_importmap_tags %>
    <%= javascript_import_module_tag("bootstrap_blob") %>
  </head>

  <body data-scrollbar-auto-hide="n" class="hold-transition sidebar-mini layout-fixed">
    <!-- Site wrapper -->
    <div class="wrapper">
      <%= render "base/header" %>
      
      <div class="content container-fluid content-container" >
        <div class="container-fluid">
          <p class="notice" style="color: green"><%= notice %></p>
          <p class="alert" style="color: red"><%= alert %></p>
          <%= yield %>
        </div>
      </div>
      
      <footer class="bg-dark bg-gradient text-center text-lg-start" style="display: none;">
        <div class="text-center p-3" style="background-color: rgba(0, 0, 0, 0.2);">copyright
          <a class="text-white">student-registration-systemcom</a>
        </div>
      </footer>
    </div>
    <!-- ./wrapper -->
  </body>
</html>

app/views/users/_form.html.erb
<%= form_with(model: user) do |form| %>
  <% if user.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
        <% user.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :first_name, style: "display: block" %>
    <%= form.text_field :first_name %>
  </div>

  <div>
    <%= form.label :last_name, style: "display: block" %>
    <%= form.text_field :last_name %>
  </div>

  <div>
    <%= form.label :email, style: "display: block" %>
    <%= form.text_field :email %>
  </div>

  <div>
    <%= form.label :phone, style: "display: block" %>
    <%= form.text_field :phone %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/users/_user.html.erb
<div id="<%= dom_id user %>">
  <p>
    <strong>First name:</strong>
    <%= user.first_name %>
  </p>

  <p>
    <strong>Last name:</strong>
    <%= user.last_name %>
  </p>

  <p>
    <strong>Email:</strong>
    <%= user.email %>
  </p>

  <p>
    <strong>Phone:</strong>
    <%= user.phone %>
  </p>

</div>

app/views/users/index.html.erb
<h2 class="text-center"> Users</h2>
<%##= button_to "New user", new_user_path, class:"new_user" %>

<div id="users">
  <% @users.each do |user| %>
    <div class="card">
      <div class="card-content">
        <%= render user %>
        <div>
          <%= link_to "Show profile", user , class:"btn-button"%>
          <br>
          <% if current_user.has_role?(:admin)%>
            <%= button_to "Remove this account", @user, method: :delete, class:"btn-button" %>
          <% end %>
        </div>
      </div>
    </div>
  <% end %>
</div>

app/views/users/show.html.erb
<h2 class="text-center"> User Details</h2>
<div class="card m-5">
  <div class="card-content">
    
    <%= render @user %>

    <div>
      <% if current_user.has_role?(:student)%>
        <%= link_to "Update", edit_user_registration_path(@user), class: "btn-button" %> 
      <% end %>
     
      <br>
      <% if current_user.has_role?(:admin)%>
        <%= button_to "Delete", @user, method: :delete , class:"btn-button"%>
      <% end %>
    </div>
  </div>
</div>